clear();
exec data3.sce
//data = data1;
data = data3;
//data = data4;

zs = size(data);
zeilen = zs(1);
spalten = zs(2);

t=zeros(zeilen,1);


t(1,1)=0;
for i=2:zeilen
    t(i,1) = t(i-1,1)+data(i-1,1);
end

t = t*0.000001;

phi_roh = data(:,3);
pwm_roh = data(:,2);
//plot(t,phi_roh);

zs = size(phi_roh);
zeilen = zs(1);
spalten = zs(2);


t_neu = 0.0:0.01:1.48;
phi_neu = interp1(t(1:zeilen,1)',phi_roh(1:zeilen,1)',t_neu);
pwm_neu = interp1(t(1:zeilen,1)',pwm_roh(1:zeilen,1)',t_neu);

//Durchführen der zentralen Ableitungen zur Gewinnung der zeitlichen Ableitungen von phi:
dt=0.01; //dt ist nun fix.

//Da für die dritte Ableitung 2 Zusatzwerte links und rechts des zentralen Wertes
//benötigt werden, reduziert sich entsprechend die Länge des neu gewonnenen Datensatzes.

phi_lsq = [];  //Kippwinkel phi
ome_lsq = [];  //Omega, zeitl. Abl. phi
alf_lsq = [];  //Alfa, zeitl. Abl. omega
dal_lsq = [];  //dalfa/dt
ttt_lsq = [];  //neue Ordinate in 0.01s Schritten
ttt=0.0;
pwm_lsq = [];  //auch das PWM-Signal muß synchron zu den anderen Daten bereitstehen.


zs = size(phi_neu');
zeilen = zs(1);


for i=3:zeilen-2
    zmm = phi_neu(1,i-2);
    zm  = phi_neu(1,i-1);
    z   = phi_neu(1,i);
    zp  = phi_neu(1,i+1);
    zpp = phi_neu(1,i+2);

    phi_lsq(i-2,1)=z;
    ome_lsq(i-2,1)=(zp-zm)/(2.0*dt);
    alf_lsq(i-2,1)=(zp-2.0*z+zm)/(dt*dt);
    dal_lsq(i-2,1)=(zpp-2.0*zp+2.0*zm-zmm)/(2.0*dt*dt*dt);
    ttt_lsq(i-2,1)=ttt;
    ttt=ttt+dt;
    pwm_lsq(i-2,1)=pwm_neu(1,i-2);
end

subplot(221);
plot(ttt_lsq,phi_lsq);

//siehe help axes_properties
a = gca();
a.x_label.text = 't/s';
a.y_label.text = 'phi';
a.title.text = 'Verlauf PHI, data1';
hl=legend(['PHI/rad'],a=1);

subplot(222);
plot(ttt_lsq,phi_lsq,ttt_lsq,ome_lsq);

//siehe help axes_properties
a = gca();
a.x_label.text = 't/s';
a.y_label.text = 'phi und omega';
a.title.text = 'Verlauf PHI und OMEGA, data1';
hl=legend(['PHI/rad';'omega/(rad/s)'],a=1);

subplot(223);
plot(ttt_lsq,ome_lsq,ttt_lsq,alf_lsq);

//siehe help axes_properties
a = gca();
a.x_label.text = 't/s';
a.y_label.text = 'omega und alfa';
a.title.text = 'Verlauf OMEGA und ALFA, data1';
hl=legend(['omega/(rad/s)';'alfa/(rad/s^2)'],a=1);

subplot(224);
plot(ttt_lsq,alf_lsq,ttt_lsq,dal_lsq);

//siehe help axes_properties
a = gca();
a.x_label.text = 't/s';
a.y_label.text = 'alfa und dalfa/dt';
a.title.text = 'Verlauf ALFA und dALFA/dt, data1';
hl=legend(['alfa/(rad/s^2)';'dalfa/(rad/s^3)'],a=1);

//Datensatz als Matrix zusammenführen und abspeichern:
matrix = [ttt_lsq,pwm_lsq,phi_lsq,ome_lsq,alf_lsq,dal_lsq];
fprintfMat('datalsq2.mat',matrix);


