class PID
{
  private:
    float integrator, ealt, differenz, imin, imax;
  public:
    float p, i, d, stellwert, e;
    
  PID( float pinit, float iinit, float dinit, float imininit, float imaxinit)
  {
    p = pinit;
    i = iinit;
    d = dinit;
    ealt = 0;
    imin = imininit;
    imax = imaxinit;
  }
  
  void reset()
  {
    e = 0;
    integrator = 0;
    ealt = 0;
  }
  
  void Regelzyklus( float istwert, float sollwert, float dt )
  {

    e = sollwert - istwert;
    differenz = ( e - ealt )/dt;
    stellwert = p*e + i*integrator + d*differenz;
    integrator += e*dt;
    if (integrator<imin) integrator = imin;
    if (integrator>imax) integrator = imax;
    ealt = e;
  }
};
